import http from '@/shopro/request/index'
import share from '@/shopro/share';

const state = {
	shop: {}, // 商城信息
	wechat: {}, // 微信配置
	share: {}, // 分享配置
	payment: {}, // 支付配置
	addons: [], // 插件配置
	chat: uni.getStorageSync("chat") || {}, // 客服配置
	store: {}, // 商城信息
	tabbarData: [], //自定义底部导航数据
	recharge: uni.getStorageSync("recharge") || {}, //充值配置

	homeTemplate: [], // 首页模板数据
	userTemplate: [], // 个人中心模板数据
	floatData: {}, // 悬浮按钮数据
	popupData: {}, // 弹窗数据
	hasTemplate: true, //是否有模板数据
	shareInfo: {} // 默认分享数据
}
const getters = {
	initShop: state => state.shop,
	initStore: state => state.store,
	initShare: state => state.share,
	initPayment: state => state.payment,
	initAddons: state => state.addons,
	initChat: state => state.chat,
	initWechat: state => state.wechat,
	initRecharge: state => state.recharge,

	hasTemplate: state => state.hasTemplate,
	homeTemplate: state => state.homeTemplate,
	userTemplate: state => state.userTemplate,
	floatData: state => state.floatData,
	popupData: state => state.popupData,
	tabbarData: state => state.tabbarData,

	shareInfo: state => state.shareInfo
}


const actions = {
	// 初始化数据
	async appInit({
		commit,
		dispatch
	}, options) {
		let config = {
			addons: ["alisms", "epay", "shopro", "summernote"],
			payment: ["wechat"],
			shop: {
				copyright: ["版权所有", "Copyright 2022-2028"],
				name: '中宏商城'
			}
		}
		commit('CONFIG', config);
		return config;
		// const result = await http('common.init');
		// if (result.code === 1) {
		// 	commit('CONFIG', config);
		// 	if (!options?.query?.token) {
		// 		dispatch('autoLogin');
		// 	}
		// 	return result.data;
		// }
		// return true;
	},

	// 获取模板数据
	async getTemplate({
		commit
	}, options) {
		let shop_id = 0;
		// #ifdef H5
		if (options?.query.shop_id) {
			shop_id = options.query.shop_id;
		}
		// #endif

		// #ifdef MP
		if (options?.query.scene) {
			let scene = decodeURIComponent(options?.query.scene);
			let sceneObj = scene.split('=');
			if (sceneObj[0] === 'shop_id') {
				shop_id = sceneObj[1]
			}
		}
		
		// #endif
		let template = {
			"home": [
				{
					"id": 27592,
					"type": "banner",
					"category": "home",
					"name": "轮播图",
					"content": {
						"name": "",
						"style": 1,
						"height": 530,
						"radius": 0,
						"x": 0,
						"y": 0,
						"list": [
							{
								"image": "http://file.shopro.top/uploads/20210522/edb232dbdf32b7e4df0eb6d079d471b6.png",
								"path": "",
								"path_type": 1,
								"name": "",
								"bgcolor": "#a71f23",
								"path_name": ""
							},
							{
								"image": "http://file.shopro.top/uploads/20210522/89e158b63896889422342043af5e741f.png",
								"path": "",
								"path_type": 1,
								"name": "",
								"bgcolor": "#e2d1c0",
								"path_name": ""
							}
						]
					},
					"decorate_id": 1
				},
				{
					"id": 27593,
					"type": "banner",
					"category": "home",
					"name": "轮播图",
					"content": {
						"name": "",
						"style": 1,
						"height": 189,
						"radius": 0,
						"x": 0,
						"y": 0,
						"list": [
							{
								"name": "",
								"bgcolor": "#fa6c2c",
								"image": "https://demo.shopro.top/uploads/20220423/4322c0d3af68cff3a1046767de847c69.png",
								"path": "",
								"path_name": "",
								"path_type": 1
							}
						]
					},
					"decorate_id": 1
				},
				{
					"id": 27594,
					"type": "menu",
					"category": "home",
					"name": "菜单组",
					"content": {
						"name": "",
						"style": 4,
						"list": [
							{
								"name": "签到有礼",
								"image": "http://file.shopro.top/uploads/20210518/884360099a48d435e23e24091fb7084f.png",
								"path": "/pages/activity/sign/index",
								"path_name": "签到中心",
								"path_type": 1
							},
							{
								"name": "品质拼团",
								"image": "http://file.shopro.top/uploads/20210518/ce173c7d81d9521350620e51b0166808.png",
								"path": "/pages/activity/groupon/list",
								"path_name": "今日必拼",
								"path_type": 1
							},
							{
								"name": "限时秒杀",
								"image": "http://file.shopro.top/uploads/20210518/cdc081320a7676753af09dbfad64b0f5.png",
								"path": "/pages/activity/seckill/list",
								"path_name": "限时秒杀",
								"path_type": 1
							},
							{
								"name": "领福利",
								"image": "http://file.shopro.top/uploads/20210518/c7b17849d22f345b4886d9a7dc6ef72a.png",
								"path": "/pages/app/coupon/list",
								"path_name": "优惠券中心",
								"path_type": 1
							},
							{
								"image": "https://demo.shopro.top/uploads/20220626/5acbdf5a34b50b1cdf092a3e5c29b76d.jpg",
								"path": "/pages/goods/list?id=163",
								"name": "日用百货",
								"path_name": "商品列表-美食酒水",
								"path_type": 1
							},
							{
								"image": "http://file.shopro.top/uploads/20210518/6dde00b61b242f8c9ed79c65d3fb0b1d.png",
								"path": "/pages/goods/list?id=44",
								"name": "居家生活",
								"path_name": "商品列表-居家生活",
								"path_type": 1
							},
							{
								"image": "http://file.shopro.top/uploads/20210518/755895207ed20ab11c141f5f2cf4946e.png",
								"path": "/pages/goods/list?id=69",
								"name": "数码电器",
								"path_name": "商品列表-数码家电",
								"path_type": 1
							},
							{
								"image": "http://file.shopro.top/uploads/20210518/9cf90a9392c7765bdfc2a5854e1295ff.png",
								"path": "/pages/goods/list?id=73",
								"name": "服装鞋包",
								"path_name": "商品列表-服饰鞋包",
								"path_type": 1
							}
						]
					},
					"decorate_id": 1
				},
				{
					"id": 27595,
					"type": "adv",
					"category": "home",
					"name": "广告魔方",
					"content": {
						"list": [
							{
								"image": "http://file.shopro.top/uploads/20210522/a31e0f90ce8765583c60012ac94f967c.png",
								"name": "",
								"path": "",
								"path_name": "",
								"path_type": 1
							},
							{
								"image": "http://file.shopro.top/uploads/20210518/cddb5d90a4241f6235d16368534bc730.png",
								"name": "",
								"path": "/pages/index/category?id=177",
								"path_name": "分类-1",
								"path_type": 1
							},
							{
								"image": "http://file.shopro.top/uploads/20210518/e047d312fb5930de972ae288b9b3bae7.png",
								"name": "",
								"path": "",
								"path_name": "",
								"path_type": 1
							}
						],
						"name": "",
						"style": 3
					},
					"decorate_id": 1
				},
				{
					"id": 27596,
					"type": "coupons",
					"category": "home",
					"name": "优惠券",
					"content": {
						"ids": "35,36",
						"name": "",
						"style": 1,
						"bgcolor1": "#EFC480",
						"bgcolor2": "#EFC480",
						"pricecolor": "#4F3A1E",
						"color": "#A8700D"
					},
					"decorate_id": 1
				},
				{
					"id": 27597,
					"type": "groupon",
					"category": "home",
					"name": "拼团",
					"content": {
						"id": 128,
						"name": "特价拼团",
						"style": 1,
						"groupon_name": "拼团",
						"team_num": "3"
					},
					"decorate_id": 1
				},
				{
					"id": 27598,
					"type": "seckill",
					"category": "home",
					"name": "秒杀",
					"content": {
						"id": 129,
						"name": "限时秒杀",
						"style": 2,
						"seckill_name": "秒杀"
					},
					"decorate_id": 1
				},
				{
					"id": 27599,
					"type": "title-block",
					"category": "home",
					"name": "标题栏",
					"content": {
						"name": "为你推荐",
						"color": "#000000",
						"image": "https://file.shopro.top/imgs/title2.png"
					},
					"decorate_id": 1
				},
				{
					"id": 27600,
					"type": "goods-list",
					"category": "home",
					"name": "自定义商品",
					"content": {
						"ids": "34,32,31,8",
						"image": "",
						"name": "",
						"style": 2
					},
					"decorate_id": 1
				},
				{
					"id": 27601,
					"type": "category-tabs",
					"category": "home",
					"name": "分类选项卡",
					"content": {
						"ids": "44,69,70,71,72,73",
						"category_arr": [
							{
								"id": 44,
								"name": "居家生活",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/b505c4c6c4aefdb3467877f2ef21c534.jpeg",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621406730,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 45,
										"name": "厨房用品",
										"type": "",
										"image": "",
										"pid": 44,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621406730,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 46,
												"name": "刀剪砧板",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/71bd6b2223883394227b9db8fdc25573.png",
												"pid": 45,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 47,
												"name": "餐厨配件",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/49c57efbed5658475e3c6391884a9272.png",
												"pid": 45,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 48,
												"name": "锅具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/537dfd7826387ee2c7000ba9f8301c09.png",
												"pid": 45,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											}
										]
									},
									{
										"id": 49,
										"name": "收纳日用",
										"type": "",
										"image": "",
										"pid": 44,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621406730,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 50,
												"name": "居家拖鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/69f29fcaaa444e884814a6991163c664.png",
												"pid": 49,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 51,
												"name": "毛巾浴巾",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/2ef329f37299b5f24f2c6dc5699ea3f3.png",
												"pid": 49,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 52,
												"name": "晾晒除味",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f803b74827a3d6184996df5f4a2f7a28.png",
												"pid": 49,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 53,
												"name": "收纳",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/5e54a0cbb4237b22288a51826ab0e2df.png",
												"pid": 49,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											}
										]
									},
									{
										"id": 54,
										"name": "家具家装",
										"type": "",
										"image": "",
										"pid": 44,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621406730,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 55,
												"name": "地毯窗帘",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/a5fbadf850f786650449b4e2dfee0731.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 56,
												"name": "灯具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f4d413ef6755330478202ba618fd28c9.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 57,
												"name": "小件家具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/aae1f4e46b7b8bc29c28a1fd793ebcca.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 58,
												"name": "办公书房家具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/b1e96baa73d4e331386d1d84fcc2d953.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 59,
												"name": "卧室家具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/72902b8ce141796b05f65545a0d31c11.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											},
											{
												"id": 60,
												"name": "客餐厅家具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/326b14421329e472a43989591cf33951.png",
												"pid": 54,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621406730,
												"updatetime": 1621406730
											}
										]
									},
									{
										"id": 61,
										"name": "家居饰品",
										"type": "",
										"image": "",
										"pid": 44,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621406730,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 63,
												"name": "居家布艺",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/d1c17ab34d58a284c376d8a85f7d774c.png",
												"pid": 61,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											},
											{
												"id": 64,
												"name": "家饰",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/83a28223fa8a74a041d3b3b005566d8e.png",
												"pid": 61,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											},
											{
												"id": 65,
												"name": "抱枕靠垫",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/5b759e8a5e9710a8fe5f91cb2825dead.png",
												"pid": 61,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											}
										]
									},
									{
										"id": 62,
										"name": "床上用品",
										"type": "",
										"image": "",
										"pid": 44,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621406730,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 66,
												"name": "床垫床褥",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/06b66796800b7f4aeab8470cb4a89321.png",
												"pid": 62,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											},
											{
												"id": 67,
												"name": "被枕盖毯",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/c47d0495436320166f7bc43b420895db.png",
												"pid": 62,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											},
											{
												"id": 68,
												"name": "床品件套",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/33d7ec68ef16a1d5f6109d1eb9a11f2e.png",
												"pid": 62,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621407084,
												"updatetime": 1621407084
											}
										]
									}
								]
							},
							{
								"id": 69,
								"name": "数码家电",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/b330cd09cd55c038c1743aef21545241.png",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621407282,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 74,
										"name": "个护电器",
										"type": "",
										"image": "",
										"pid": 69,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 75,
												"name": "头发护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/b1621ccc627b56b950cedd127ff9670d.png",
												"pid": 74,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 76,
												"name": "身体护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/58ad6a858055d8856cdcc2c2e5a6f34b.png",
												"pid": 74,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 77,
												"name": "口腔护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/fd6c18d2bcc98f9efdb5dc360d21d8f5.png",
												"pid": 74,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									},
									{
										"id": 78,
										"name": "数码办公",
										"type": "",
										"image": "",
										"pid": 69,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 79,
												"name": "车载用品",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/20d3c8c3fd8d66bfaf2e087503cede1d.png",
												"pid": 78,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 80,
												"name": "手机配件",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/4ebc26813030ee6870e06c7671973d0d.png",
												"pid": 78,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 81,
												"name": "3C数码",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/17fe8d63f3e33700a555d42ad4005aaa.png",
												"pid": 78,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									},
									{
										"id": 82,
										"name": "生活电器",
										"type": "",
										"image": "",
										"pid": 69,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 83,
												"name": "空气调节",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/d90a03d7b31787af2173cae27ff0ca71.png",
												"pid": 82,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 84,
												"name": "衣物护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/99459989079cab8b6e1de8da20fa8078.png",
												"pid": 82,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 85,
												"name": "清洁电器",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/1cc8b5c44d6c3d0e136ba4717f1f96f6.png",
												"pid": 82,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 86,
												"name": "两季电器",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/b52a0191f1092abc22701185a8ca2b6d.png",
												"pid": 82,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									}
								]
							},
							{
								"id": 70,
								"name": "运动旅行",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/225422d99ca344883fc5a1a52a6f2ad5.png",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621407282,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 87,
										"name": "运动健身",
										"type": "",
										"image": "",
										"pid": 70,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 88,
												"name": "瑜伽美体",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f1220b340e780b2ff00f54127cf751b0.png",
												"pid": 87,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 89,
												"name": "按摩护具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/ccfd1de922f35e721b56baf680279330.png",
												"pid": 87,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									},
									{
										"id": 90,
										"name": "女子运动",
										"type": "",
										"image": "",
										"pid": 70,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 91,
												"name": "女士运动鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/3b9a6bc539c0050bbeb4d4c859b2e71d.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 92,
												"name": "女士运动内衣/泳装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/2fb83b8cae4f3566df54bb4e766d02f5.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 93,
												"name": "女士运动T恤",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/598c06df8cc64a6927ecf3a68c12005a.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 94,
												"name": "女士户外服装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/6f7365b7982b658790cf505f6c1c50d2.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 95,
												"name": "女士运动裤装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/76e48d40c43fe2ba0ebbd0118cfe51a3.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 96,
												"name": "女士运动外套/卫衣",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/5ddb25444b3baa0b14b22ab4ea92fd06.png",
												"pid": 90,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									},
									{
										"id": 97,
										"name": "男子运动",
										"type": "",
										"image": "",
										"pid": 70,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408286,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 98,
												"name": "男士运动鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/22de478fafea0dd85b2dd2183578ad92.png",
												"pid": 97,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 99,
												"name": "男士运动T恤",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/3f6dce5eed0586c86f07aa4abf060558.png",
												"pid": 97,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 100,
												"name": "男士户外服装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/9ad4a70998bc4ef2c1eafe7debb7d769.png",
												"pid": 97,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 101,
												"name": "男士运动裤装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/9536e3e327f1a66513367c1282522e6a.png",
												"pid": 97,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											},
											{
												"id": 102,
												"name": "男士运动外套/卫衣",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/a21cdca293151bd1c36af393d251424a.png",
												"pid": 97,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408286,
												"updatetime": 1621408286
											}
										]
									}
								]
							},
							{
								"id": 71,
								"name": "亲子母婴",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/05ecdfeaee42cefa15834966a09a6bb9.png",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621407282,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 103,
										"name": "玩具图书",
										"type": "",
										"image": "",
										"pid": 71,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408757,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 104,
												"name": "图书",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/125d48b497de8bce7e7febc4dac75696.png",
												"pid": 103,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 105,
												"name": "文具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/5447e331c98cdd480ada05313009183a.png",
												"pid": 103,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 106,
												"name": "玩具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/d8957062909571aaff1bbc213f39e1b9.png",
												"pid": 103,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											}
										]
									},
									{
										"id": 107,
										"name": "洗护喂养",
										"type": "",
										"image": "",
										"pid": 71,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408757,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 108,
												"name": "喂养",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/6262e491bb4ea126faf827a9088eb559.png",
												"pid": 107,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 109,
												"name": "洗护",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/210c7ee394f1dd07f0664ed619831cee.png",
												"pid": 107,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 110,
												"name": "尿裤纸品",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/87900549416a72ee49840d2162279ef9.png",
												"pid": 107,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											}
										]
									},
									{
										"id": 111,
										"name": "童鞋",
										"type": "",
										"image": "",
										"pid": 71,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408757,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 112,
												"name": "学步鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/7ae6ac376930ae33be3be5e525a4997d.png",
												"pid": 111,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 113,
												"name": "儿童鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/e5069eb86f34ad29a9ea6e2e4f3278b0.png",
												"pid": 111,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											}
										]
									},
									{
										"id": 114,
										"name": "童装",
										"type": "",
										"image": "",
										"pid": 71,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621408757,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 115,
												"name": "内衣/配搭",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/55edea5dc20a0888a2de713cb496717f.png",
												"pid": 114,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 116,
												"name": "连体衣/礼盒",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/896a113bc7af9a5ba765dd0cd42decf9.png",
												"pid": 114,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 117,
												"name": "外套/套装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/caa7b8e17dabf96d2b97738f5013cc21.png",
												"pid": 114,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											},
											{
												"id": 118,
												"name": "卫衣/毛衫",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f85c23f234d67e40cb2848c7c5e422e9.png",
												"pid": 114,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621408757,
												"updatetime": 1621408757
											}
										]
									}
								]
							},
							{
								"id": 72,
								"name": "个护清洁",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/ea0eef9b5e58af66347cfd8fa5d5e308.png",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621407282,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 119,
										"name": "彩妆香水",
										"type": "",
										"image": "",
										"pid": 72,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409206,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 120,
												"name": "美妆工具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f3a5185b18c56d48a7aa2c5b392dcb16.png",
												"pid": 119,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 121,
												"name": "香水香氛",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/6448fdf8d73ac95cb83eacb35d01dc1e.png",
												"pid": 119,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 122,
												"name": "彩妆修容",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f830c911ead7a24d38e45ebd54da0b0f.png",
												"pid": 119,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											}
										]
									},
									{
										"id": 123,
										"name": "个人护理",
										"type": "",
										"image": "",
										"pid": 72,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409206,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 124,
												"name": "女性护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/c1a7752d7a840fc92f3972c0cf6d720a.png",
												"pid": 123,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 125,
												"name": "口腔护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/295d569d562beb7623f5897d3405e4fb.png",
												"pid": 123,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 126,
												"name": "身体护理",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/8f3f39bd122b926e168db31e65b33de9.png",
												"pid": 123,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 127,
												"name": "洗发护发",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/93e2d689cff40f40a9fdecccf0d1e906.png",
												"pid": 123,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											}
										]
									},
									{
										"id": 128,
										"name": "面部护理",
										"type": "",
										"image": "",
										"pid": 72,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409206,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 129,
												"name": "护肤工具",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/1391b0998e6e3226b156d67a3d23e869.png",
												"pid": 128,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 130,
												"name": "卸妆洁面",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/d85e0d073a65011d047bedd7edb4b7e9.png",
												"pid": 128,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											},
											{
												"id": 131,
												"name": "基础护肤",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/347674f375179016e010ea186d6b1cbb.png",
												"pid": 128,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409206,
												"updatetime": 1621409206
											}
										]
									}
								]
							},
							{
								"id": 73,
								"name": "服饰鞋包",
								"type": "",
								"image": "http://file.shopro.top/uploads/20210519/cbe5177c5c987ec72830fa936307b751.png",
								"pid": 43,
								"weigh": 0,
								"description": "",
								"status": "normal",
								"createtime": 1621407282,
								"updatetime": 1663139447,
								"children": [
									{
										"id": 144,
										"name": "箱包",
										"type": "",
										"image": "",
										"pid": 73,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409861,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 145,
												"name": "行李箱",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/09cb8ccd7257759bd4d6b8c9d7108ced.png",
												"pid": 144,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 146,
												"name": "钱包及小皮件",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/4e4129fcdae5ffdbfcd38bd804d9f4b3.png",
												"pid": 144,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 147,
												"name": "女士包袋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/11e467ccfee62a802b9dd520b5bc4b10.png",
												"pid": 144,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 148,
												"name": "男士包袋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/02a10cd84196c1dd059a4d107add889a.png",
												"pid": 144,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											}
										]
									},
									{
										"id": 149,
										"name": "鞋靴",
										"type": "",
										"image": "",
										"pid": 73,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409861,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 150,
												"name": "鞋配",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/4d7c5428d8b39000a1a07b9cffcb1fc8.png",
												"pid": 149,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 151,
												"name": "拖鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/f0f4c0e2cec6cb326312b42f045a20fc.png",
												"pid": 149,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 152,
												"name": "女鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/0aceb062c4bbf75ebe59aff542871b0c.png",
												"pid": 149,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 153,
												"name": "男鞋",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/c7c11ea39df1c16fe9c098e0243bfd25.png",
												"pid": 149,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											}
										]
									},
									{
										"id": 154,
										"name": "女装",
										"type": "",
										"image": "",
										"pid": 73,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409861,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 155,
												"name": "女士外套",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/bdfb38417cb9058be3a89c6b8c8ee2c6.png",
												"pid": 154,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 156,
												"name": "女式衬衫",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/02be3efee5d0ad3690d012241e4f786e.jpeg",
												"pid": 154,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 157,
												"name": "女士裙装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/4285eb455cf4ba396985b60db99b2952.png",
												"pid": 154,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											}
										]
									},
									{
										"id": 158,
										"name": "男装",
										"type": "",
										"image": "",
										"pid": 73,
										"weigh": 0,
										"description": "",
										"status": "normal",
										"createtime": 1621409861,
										"updatetime": 1663139447,
										"children": [
											{
												"id": 159,
												"name": "男士裤装",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/b9fe1efe2b26eb0f060a26bae677d30d.jpeg",
												"pid": 158,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 160,
												"name": "男士卫衣",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/13f08a3efeeb2b91890efdc4e096ab61.jpeg",
												"pid": 158,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 161,
												"name": "男士衬衫",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/80749ed38259d70d2347a9d3157421bd.png",
												"pid": 158,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											},
											{
												"id": 162,
												"name": "男士外套",
												"type": "",
												"image": "http://file.shopro.top/uploads/20210519/33aebe2cedf450ac6d0bbde0034635d3.png",
												"pid": 158,
												"weigh": 0,
												"description": "",
												"status": "normal",
												"createtime": 1621409861,
												"updatetime": 1621409861
											}
										]
									}
								]
							}
						],
						"style": 1
					},
					"decorate_id": 1
				}
			],
			"user": [
				{
					"id": 27604,
					"type": "user",
					"category": "user",
					"name": "用户卡片",
					"content": {
						"name": "用户卡片",
						"image": "http://file.shopro.top/uploads/20210518/c4e353836a5d04e92697d22f95d0c5a5.png",
						"style": 2,
						"color": "#eeeeee"
					},
					"decorate_id": 1
				},
				{
					"id": 27605,
					"type": "order-card",
					"category": "user",
					"name": "订单卡片",
					"content": [
						
					],
					"decorate_id": 1
				},
				{
					"id": 27606,
					"type": "wallet-card",
					"category": "user",
					"name": "资产卡片",
					"content": [
						
					],
					"decorate_id": 1
				},
				{
					"id": 27607,
					"type": "grid-list",
					"category": "user",
					"name": "宫格列表",
					"content": {
						"name": "",
						"list": [
							{
								"name": "商品收藏",
								"image": "http://file.shopro.top/uploads/20210518/b726f027bd679f0f5a36c6e301430790.png",
								"path": "/pages/user/favorite",
								"path_name": "我的收藏",
								"path_type": 1
							},
							{
								"name": "浏览足迹",
								"image": "http://file.shopro.top/uploads/20210518/d4e05c1560722ec63fde08e3217d3296.png",
								"path": "/pages/user/view-log",
								"path_name": "浏览足迹",
								"path_type": 1
							},
							{
								"name": "积分商城",
								"image": "http://file.shopro.top/uploads/20210518/234139fd11f6f8451e4c517f256c6b45.png",
								"path": "/pages/app/score/list",
								"path_name": "积分商品",
								"path_type": 1
							},
							{
								"name": "我的拼团",
								"image": "http://file.shopro.top/uploads/20210518/5d53a6e7f940c5ef925f63c1810c8429.png",
								"path": "/pages/activity/groupon/my-groupon",
								"path_name": "我的拼团",
								"path_type": 1
							},
							{
								"name": "常见问题",
								"image": "http://file.shopro.top/uploads/20210518/555ef0a1151e83014610b288e53827c2.png",
								"path": "/pages/public/faq",
								"path_name": "常见问题",
								"path_type": 1
							},
							{
								"name": "系统设置",
								"image": "http://file.shopro.top/uploads/20210518/9ac9ef6f9df49f89ace437c53a76adca.png",
								"path": "/pages/user/set",
								"path_name": "系统设置",
								"path_type": 1
							},
							{
								"name": "分销中心",
								"image": "http://file.shopro.top/uploads/20210518/a470b691a09eec29d56e0a55b02f70e0.png",
								"path": "/pages/app/commission/index",
								"path_name": "分销中心",
								"path_type": 1
							},
							{
								"name": "团长申请",
								"image": "http://file.shopro.top/uploads/20210518/ccb0390403a473d6b019d330bbf6bca4.png",
								"path": "/pages/app/merchant/apply",
								"path_name": "门店入驻",
								"path_type": 1
							}
						]
					},
					"decorate_id": 1
				}
			],
			"tabbar": [
				{
					"id": 27603,
					"type": "tabbar",
					"category": "tabbar",
					"name": "底部导航",
					"content": {
						"style": 1,
						"color": "#666666",
						"activeColor": "#EFC480",
						"bgcolor": "#fff",
						"list": [
							{
								"name": "首页",
								"image": "https://demo.shopro.top/uploads/20221017/c4591c74c27a49bda021257d3c889225.png",
								"activeImage": "https://demo.shopro.top/uploads/20221017/558feb98726495d17128d07694d7ff47.png",
								"path": "/pages/index/index",
								"path_name": "首页",
								"path_type": 1
							},
							{
								"name": "分类",
								"image": "https://demo.shopro.top/uploads/20221017/d6e987bb27013691478ddce7ce700288.png",
								"activeImage": "https://demo.shopro.top/uploads/20221017/f280b7f9ea18db0c80337d1c1cac6075.png",
								"path": "/pages/index/category?id=43",
								"path_name": "分类-商品分类",
								"path_type": 1
							},
							{
								"name": "购物车",
								"image": "https://demo.shopro.top/uploads/20221017/0ab4659f44404d6d4723c265ccd21f94.png",
								"activeImage": "https://demo.shopro.top/uploads/20221017/5273d6e90fb45e3d9189fba9fcbea47c.png",
								"path": "/pages/index/cart",
								"path_name": "购物车",
								"path_type": 1
							},
							{
								"name": "我的",
								"image": "https://demo.shopro.top/uploads/20221017/406848d5827325fead27224decffd141.png",
								"activeImage": "https://demo.shopro.top/uploads/20221017/8eca666cc43686d292113244b31e0664.png",
								"path": "/pages/index/user",
								"path_name": "我的",
								"path_type": 1
							}
						],
						"isshow": true
					},
					"decorate_id": 1
				}
			],
			"popup": [
				{
					"id": 27602,
					"type": "popup",
					"category": "popup",
					"name": "弹窗提醒",
					"content": {
						"list": [
							{
								"name": "",
								"style": 2,
								"image": "http://file.shopro.top/uploads/20210518/9136ecddcddf6607184fab689207e7e3.png",
								"btnimage": "",
								"path": "/pages/app/coupon/list",
								"path_name": "优惠券中心",
								"path_type": 1
							}
						]
					},
					"decorate_id": 1
				}
			],
			"float-button": [
				{
					"id": 27608,
					"type": "float-button",
					"category": "float-button",
					"name": "悬浮按钮",
					"content": {
						"image": "http://file.shopro.top/uploads/20210518/f6b9c9d20d21df541ac52e9548486e1a.png",
						"list": [
							{
								"name": "关注",
								"style": 1,
								"image": "http://file.shopro.top/uploads/20210522/ff3fba3ef6a402aa770bde5a60e7f49f.png",
								"btnimage": "http://file.shopro.top/uploads/20210522/1f4ee09203ca1ae620137925d77275d7.png",
								"path": "",
								"path_name": "",
								"path_type": 1
							},
							{
								"name": "活动",
								"style": 2,
								"image": "",
								"btnimage": "http://file.shopro.top/uploads/20210522/5c50e0b17d64f448d271cfaac5039e00.png",
								"path": "/pages/activity/groupon/list",
								"path_name": "今日必拼",
								"path_type": 1
							},
							{
								"name": "客服",
								"style": 2,
								"image": "",
								"btnimage": "http://file.shopro.top/uploads/20210522/73234ab79bd6164b11f09a1b11df3f55.png",
								"path": "/pages/public/chat/index",
								"path_name": "客服",
								"path_type": 1
							}
						]
					},
					"decorate_id": 1
				}
			]
		}
		commit("hasTemplate", true);
		commit('TEMPLATE', template);
		return template;
		// const result = await http('common.template', shop_id ? {
		// 	shop_id
		// } : {});
		// if (result.code === 1) {
		// 	commit("hasTemplate", true);
		// 	commit('TEMPLATE', result.data);
		// 	return result.data;
		// } else {
		// 	commit("hasTemplate", false);
		// 	return false;
		// }
	},

	// 同步路由到后端
	syncPages({
		commit
	}) {
		// http('common.syncPages', {
		// 	data: ROUTES,
		// })
	},
}


const mutations = {
	CONFIG(state, payload) {
		Object.keys(payload).forEach(k => {
			state[k] = payload[k];
			if (k === 'chat') {
				uni.setStorageSync("chat", payload[k]);
			}
			if (k === 'recharge') {
				uni.setStorageSync("recharge", payload[k])
			}
		})
	},

	TEMPLATE(state, data) {
		state.template = data;
		state.homeTemplate = data.home
		state.userTemplate = data.user
		state.floatData = data['float-button']?. [0]?.content
		state.popupData = {}
		state.tabbarData = data?.tabbar?. [0]?.content
	},

	hasTemplate(state, data) {
		state.hasTemplate = data
	},
	// 弹窗一次的话，关闭的时候删除数据。
	delPopup(state, index) {
		let popupData = state.popupData;
		popupData.list.splice(index, 1)
		state.template = popupData;
	},
	shareInfo(state, shareInfo) {
		state.shareInfo = shareInfo;
	}
}


export default {
	state,
	mutations,
	actions,
	getters
}
